

import pandas as pd
import json
import os
import datetime    
import pytz
import time
arr_json_data = []
 
 
obj_example = {
                "id": 13885751,
                "exchange": "pump_amm",
                "address": "qbSzQDgU32NYGkdjkKgX15ba9NRUdFdDkPHbMnnQia9",
                "base_address": "6GGbp8CZdv7mYhkyf3nTZVi6PGeT4naPH5fWr3nupump",
                "quote_address": "So11111111111111111111111111111111111111112",
                "quote_reserve": "150.9787",
                "initial_liquidity": "24759.392",
                "initial_quote_reserve": "84.9904",
                "pool_type": 11,
                "pool_type_str": "pumpamm",
                "launchpad_platform": "pool_pump_amm",
                "quote_symbol": "SOL",
                "base_token_info": {
                    "symbol": "chillaura",
                    "name": "just a chill aura",
                    "logo": "https://gmgn.ai/external-res/7805859e61907526c865a0f677b99297.webp",
                    "total_supply": 999982156,
                    "price": "0.0001611",
                    "holder_count": 1306,
                    "price_change_percent1m": "0.3951",
                    "price_change_percent5m": "3.3431",
                    "price_change_percent1h": "54.9635",
                    "burn_ratio": "1.0000",
                    "burn_status": "burn",
                    "is_show_alert": False,
                    "hot_level": 0,
                    "liquidity": "43689.8754",
                    "top_10_holder_rate": 0.171558,
                    "renounced_mint": 1,
                    "renounced_freeze_account": 1,
                    "social_links": {
                        "twitter_username": "i/communities/1933766357172031564",
                        "website": None,
                        "telegram": None
                    },
                    "dexscr_update_link": 1,
                    "cto_flag": 1,
                    "twitter_rename_count": 0,
                    "twitter_del_post_token_count": 0,
                    "twitter_create_token_count": 0,
                    "rug_ratio": 1,
                    "sniper_count": 6,
                    "smart_degen_count": 0,
                    "renowned_count": 4,
                    "market_cap": "161126.2448",
                    "is_wash_trading": False,
                    "creator": "2QckYteSFsbyYLQxGxnP6KcUJAyLfRMe962TiqdrWwFp",
                    "creator_created_inner_count": 5,
                    "creator_created_open_count": 1,
                    "creator_created_open_ratio": "0.167",
                    "creator_balance_rate": "0.00000000003464",
                    "creator_token_status": "creator_close",
                    "rat_trader_amount_rate": 0,
                    "bundler_trader_amount_rate": "0.00284",
                    "bluechip_owner_percentage": 0.01225114854517611,
                    "volume": "1534250.8633",
                    "swaps": 23072,
                    "buys": 12947,
                    "sells": 10125,
                    "buy_tax": None,
                    "sell_tax": None,
                    "is_honeypot": None,
                    "renounced": None,
                    "dev_token_burn_amount": None,
                    "dev_token_burn_ratio": None,
                    "dexscr_ad": 0,
                    "twitter_change_flag": 0,
                    "address": "6GGbp8CZdv7mYhkyf3nTZVi6PGeT4naPH5fWr3nupump"
                },
                "open_timestamp": 1749888587,
                "launchpad": "Pump.fun",
                "bot_degen_count": "30"
            }
    
 
arr_store_keys = [
    

"address",
"base_address",
"quote_reserve",
"initial_quote_reserve",
"symbol",
"name",
"holder_count",
"burn_status",
"liquidity",
"top_10_holder_rate",
"renounced_mint",
"renounced_freeze_account",
"rug_ratio",
"market_cap",
"creator",
"swaps",
"open_timestamp",

 
        
]
 
def flatten_dict(d):
    flat_dict = {}
    for key, value in d.items():
        if isinstance(value, dict):
            nested_dict = flatten_dict(value)
            for nested_key, nested_value in nested_dict.items():
                flat_dict[ nested_key] = nested_value
            # 添加每一层dict的名字
            # for nested_key, nested_value in nested_dict.items():
            #     flat_dict[key + '.' + nested_key] = nested_value
        else:
            flat_dict[key] = value
    return flat_dict


def makeurl( url,url_show):
    return '=HYPERLINK("{}","{}")'.format(url,  url_show)
    
def get_handle_json_pump():

    global arr_file  , arr_json_data
    # arr_file = []
    cur_file = arr_file[0]
 
    with open(f'{cur_file}', 'r',encoding='utf8') as f:
        old_arr_json_data = json.load(f)
 
    
    for obj in old_arr_json_data:
        filtered_obj = {}
        # 遍历obj的每一个value 元素 
        obj = flatten_dict(obj)
        
        for key, value in obj.items():
            if key in arr_store_keys:
                if True:
                    filtered_obj[key] = value
            else:
                continue
                
        arr_json_data.append(filtered_obj)
    
    return

def utc_2_shanghaidate(df , utc_time_col ):
# 将字符串转换为UTC时间的datetime对象
    # df[utc_time_col] = pd.to_datetime(df[utc_time_col], utc=True)
    # 定义UTC+8时区
    utc_plus_8 = pytz.timezone('Asia/Shanghai')
    # 转换为UTC+8时间
    df[utc_time_col] = df[utc_time_col].dt.tz_localize('UTC')
    # # 提取时间字符串
    # df['shanghai_date'] = df['shanghai_date'].dt.strftime('%Y-%m-%d %H:%M')
    df[utc_time_col] = df[utc_time_col].dt.tz_convert(utc_plus_8)
    # 提取时间字符串
    df[utc_time_col] = df[utc_time_col].dt.strftime('%Y-%m-%d %H:%M')
    return df

 

def arr_json_2_df():
    global arr_json_data
    df  = pd.DataFrame(arr_json_data)
 
 
    df['pair_address'] = df['address']  
    df['token_address'] = df['base_address']
    df['quote_reserve'] = df['quote_reserve'].astype(float)
    df['liquidity'] = df['liquidity'].astype(float)
    df['mc_usd_k'] = df['market_cap'].astype(float) / 1e3
 
    df['swaps_count'] = df['swaps']
    df['rug_ratio'] = df['rug_ratio']
    df['token_symbol'] = df['symbol'].str.strip()
    df['token_name'] = df['name'].str.strip()
    df['holder'] = df['holder_count']
    df['burn_status'] = df['burn_status']
    df['top_10_holder_rate'] = df['top_10_holder_rate'].fillna(0)
    df['renounced_mint'] = df['renounced_mint']
    df['renounced_freeze_account'] = df['renounced_freeze_account']
    df['creator'] = df['creator']

    df["open_timestamp"] = pd.to_datetime(df["open_timestamp"], unit='s'  )
    df = utc_2_shanghaidate(df, "open_timestamp")

 
    df["gmgn"] = df.apply(lambda ser: makeurl(
    f"https://gmgn.ai/sol/token/{ser['token_address']}" , "gmgn" ), axis=1)


    df["defined"] = df.apply(lambda ser: makeurl(
     f"https://www.defined.fi/sol/{ser['token_address']}" , "defined" ), axis=1)
    
    df["beizhu"] = None
    df =df [[  
             
        "pair_address",
        "token_address",
        "token_symbol",
        "token_name",
        "holder",
        "burn_status",
        "top_10_holder_rate",
        "renounced_mint",
        "renounced_freeze_account",
        "creator",
        "quote_reserve",
        "liquidity",
   
         "mc_usd_k",
        "swaps_count",
        "rug_ratio",
        "open_timestamp",
        
 
        "gmgn",
        "defined",
        "beizhu"
        ]]
    df =df.round(1)
 

    


# 获取当前日期和时间
    nowtime = datetime.datetime.now()

    # 将日期和时间格式化为字符串
    nowtime_str = nowtime.strftime("%Y-%m%dday%H%M")
    
 
    df.to_excel(f'pump_completed_gmgn_{nowtime_str}.xlsx',index=False)
 

arr_file = []
dir_file = "./"
arr_file = [file for file in os.listdir(dir_file) if( file.endswith('.json') and "pump_completed_gmgn_" in file) ]
arr_file.sort(reverse=True)
 
get_handle_json_pump()
arr_json_2_df()


 